POJ_2392_SpaceElevator(多重背包)

Space Elevator
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 10883   Accepted: 5185

Description

The cows are going to space! They plan to achieve orbit by building a sort of space elevator: a giant tower of blocks. They have K (1 <= K <= 400) different types of blocks with which to build the tower. Each block of type i has height h_i (1 <= h_i <= 100) and is available in quantity c_i (1 <= c_i <= 10). Due to possible damage caused by cosmic rays, no part of a block of type i can exceed a maximum altitude a_i (1 <= a_i <= 40000).

Help the cows build the tallest space elevator possible by stacking blocks on top of each other according to the rules.

Input

* Line 1: A single integer, K

* Lines 2..K+1: Each line contains three space-separated integers: h_i, a_i, and c_i. Line i+1 describes block type i.

Output

* Line 1: A single integer H, the maximum height of a tower that can be built

Sample Input

3
7 40 3
5 23 8
2 52 6

Sample Output

48

Hint

OUTPUT DETAILS:

From the bottom: 3 blocks of type 2, below 3 of type 1, below 6 of type 3. Stacking 4 blocks of type 2 and 3 of type 1 is not legal, since the top of the last type 1 block would exceed height 40.

Source

USACO 2005 March Gold


题意

给出了一些砖块

砖块有高度,最高可以达到的高度和数量

问最高可以摞多高的塔


解题思路

按照砖块最大高度排序

因为最大高度小的砖块先选肯定优于后选(贪心)

随后对于每个砖块做多重背包就可以了

注意的就是最后最大高度的dp[mh]不一定是最优解

因为这个dp[mh]的最值是从上一步过来的

而由于上一步dp的mh更小,因此dp数组存在断档

要最后从头扫一遍才能得出最优解


#include 
#include 
#include 
#include 
using namespace std;

const int MV=4e4+5;
const int MN=40005;
int dp[MV];
int vm;
struct Block
{
    int h,mh,n;
    bool operator<(Block a)const
    {
        return mh=vi;i--)
        dp[i]=max(dp[i],dp[i-vi]+wi);
}
void _cp(int vi,int wi)//完全背包子过程
{
    for(int i=vi;i<=vm;i++)
        dp[i]=max(dp[i],dp[i-vi]+wi);
}
void _mulp(int vi,int wi,int ni)//多重背包子过程
{
    if(wi*ni>=vm)
    {
        _cp(vi,wi);
        return;
    }
    int k=1;
    while(k

你可能感兴趣的:(POJ,背包dp,经典问题)